



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JS设计模式（二） 惰性模式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JS设计模式（二） 惰性模式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 02:44:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/5266042-1f0d1bdc6a06f32b.jpg?imageMogr2/auto-orient/strip%7CimageView2/2"><br /><br />
<strong>惰性模式</strong>：减少代码每次执行时的重复性判断，通过重新定义对象来避免原对象中的分支判断，提高网站性能。</p>
<p>例如针对不同浏览器的事件注册方法：</p>
<pre class="prettyprint linenums"><code>var AddEvent = function(dom, type, fn){<br />
  if(dom.addEventListener){<br />
  	dom.addEventListener(type, fn, false);<br />
  }else if(dom.attachEvent){<br />
  	dom.attachEvent('on'+type, fn);<br />
  }else{<br />
  	dom['on'+type] = fn;<br />
  }<br />
}<br />
</code></pre>
<p>从上面的方法可以发现，每次为元素绑定事件时，都会进行检测判断，这是多余的，因为在同一浏览器中分支判断结果是唯一的，不可能走不同的分支。</p>
<p>我们可以用惰性模式来解决这个问题，既然第一次调用该方法时已经判断过了，那么就可以在第一次执行时根据判断结果重新定义该方法。</p>
<p>惰性模式主要有两种实现方法：</p>
<ul><li>加载即执行：JavaScript文件加载时通过闭包执行对方法进行重新定义，在页面加载时会消耗一定的资源。</li></ul>
<pre class="prettyprint linenums"><code>var AddEvent = function(dom, type, fn){<br />
  if(dom.addEventListener){<br />
  	return function(dom, type, fn){<br />
  		dom.addEventListener(type, fn, false);<br />
      }<br />
  }else if(dom.attachEvent){<br />
  	return function(dom, type, fn){<br />
    	dom.attachEvent('on'+type, fn);<br />
      }<br />
  }else{<br />
  	return function(dom, type, fn){<br />
  		dom['on'+type] = fn;<br />
      }<br />
  }<br />
}();<br />
</code></pre>
<ul><li>惰性执行：第一次执行函数时在函数内部对其进行显示重写，最后调用重写后的方法完成第一次方法调用。</li></ul>
<pre class="prettyprint linenums"><code>var AddEvent = function(dom, type, fn){<br />
  if(dom.addEventListener){<br />
  	AddEvent = function(dom, type, fn){<br />
  		dom.addEventListener(type, fn, false);<br />
      }<br />
  }else if(dom.attachEvent){<br />
  	AddEvent = function(dom, type, fn){<br />
    	dom.attachEvent('on'+type, fn);<br />
      }<br />
  }else{<br />
  	AddEvent = function(dom, type, fn){<br />
  		dom['on'+type] = fn;<br />
      }<br />
  }<br />
 AddEvent(dom, type, fn);<br />
};<br />
</code></pre>
<p>与<strong>加载即执行</strong>不同的是，JS文件加载完成后，<strong>惰性执行</strong>的函数还没有被重新定义，当函数被首次调用时才会被重定义。这两种惰性方式都避免了冗余的分支判断。</p>
<p>惰性模式的应用场景非常广泛，特别是当今浏览器种类繁多的现象，很多功能在不同浏览器中实现不一，为了兼容不同的浏览器，代码中往往会有许多对不同浏览器的分支判断，比如事件处理、XMLHttpRequest对象创建等，造成代码臃肿冗余，惰性模式正好可以解决这种问题，提高代码执行效率。</p>
<blockquote><p>本文为作者<a href="http://www.jianshu.com/u/7c65dc20fdaa" rel="external nofollow noreferrer">kMacro</a>原创，转载请注明来源：<a href="http://www.jianshu.com/p/9a7be94a3ea7%E3%80%82" rel="external nofollow noreferrer">http://www.jianshu.com/p/9a7be94a3ea7。</a></p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m2jo6q.html">Hadoop学习笔记&mdash;13&period;分布式集群中节点的动态添加与下架</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4j5ojq.html">c&plus;&plus;编译器对多态的实现原理总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96g5w48.html">Bean 的作用域</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j423w9.html">C&plus;&plus;编程优化心得（持续更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vm7gm8.html">opencv实现图片缩放</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1oge59.html">联想Z470安装10&period;11懒人版成功！！特此分享！！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvdzgxq.html">HDU1542 Atlantis&lpar;矩形面积并&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn5kmz8.html">从零开始学ios开发（十三）：Table Views（下）Grouped and Indexed Sections</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdpm5l8.html">&lbrack;Machine Learning&rsqb; 梯度下降（BGD）、随机梯度下降（SGD）、Mini-batch Gradient Descent、带Mini-batch的SGD</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p67zn8.html">cadence单一原理图库的设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mw6p38.html">office全系列激活脚本-改良版&period;cmd</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvxdjz8.html">深入浅出的webpack构建工具---webpack基本配置&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn6yx4q.html">记一次简单爬虫&lpar;豆瓣&sol;dytt&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjlknvq.html">BZOJ&period;3611&period;&lbrack;HEOI2014&rsqb;大工程&lpar;虚树 树形DP&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx23gkj8.html">Installing Vim 8&period;0 on Ubuntu 16&period;04 and Linux Mint 18</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mde0no8.html">搜索下拉  select美化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jemzv08.html">js中返回上一页</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jev37w8.html">如何让JS变量和字符串拼接后，是变量而不是字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15xx359.html">AVplayer搭建ftp共享PC端</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvdyjkoq.html">Object和Thread自带的原生方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdpgjvxq.html">GreenOpenPaint简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpko3j9.html">&lpar;转载&rpar;理解Java中的引用传递和值传递</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z27yx9.html">Ubuntu 14&period;04 安装LNMP（nginx&sol;1&period;12&period;1&plus;php7&period;1&period;9&plus;mysql5&period;7&period;19）环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jgm6v8.html">xcode模拟器不显示键盘解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gez4n48.html">java 比较几种常见循环方式的优劣</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y3new8.html">poj 1742 多重背包</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kyl349.html">kickstart部署及使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/950z7de8.html">201521123035《Java程序设计》第六周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo6lk3q.html">201521123111《Java程序设计》第2周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1j74yq.html">evak购物车--课程设计（201521123037邱晓娴）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
